clear all
close all
% u''(x)+u'(x)+u(x)-cos(x)=0
% u(0)=0
% u(pi/2)=1
% differenze finite
a = 0;
b = pi/2;
mrif = 1001;
m = mrif;
x = linspace(a,b,m)';
h = (b-a)/(m-1);
A = toeplitz(sparse([-2,1,zeros(1,m-2)])/h^2);
B = toeplitz(sparse([0,-1,zeros(1,m-2)])/(2*h),...
	     sparse([0,1,zeros(1,m-2)])/(2*h));
M = A+B+speye(m);
M(1,1) = 1/h^2;
M(1,2) = 0;
M(m,m-1) = 0;
M(m,m) = 1/h^2;
rhs = cos(x);
rhs(1) = 0;
rhs(m) = 1/h^2;
urif = M\rhs;
%mrange = [6,11,21,51,101,201,501];
mrange = [21,51,101];
counter = 0;
for m = mrange
  counter = counter+1;
  x = linspace(a,b,m)';
  h = (b-a)/(m-1);
  A = toeplitz(sparse([1,1],[1,2],[-2,1]/h^2,1,m));
  B = toeplitz(sparse(1,2,-1/(2*h),1,m),...
	       sparse(1,2,1/(2*h),1,m));
  M = A+B+speye(m);
  M(1,1) = 1/h^2;
  M(1,2) = 0;
  M(m,m-1) = 0;
  M(m,m) = 1/h^2;
  rhs = cos(x);
  rhs(1) = 0;
  rhs(m) = 1/h^2;
  u = M\rhs;
  err(counter) = norm(u-urif(1:(mrif-1)/(m-1):mrif),Inf);
  erran(counter) = norm(u-sin(x),Inf);
end
loglog(mrange,err,'*',mrange,erran(end)*(mrange/mrange(end)).^(-2),mrange,erran,'o')
legend('errore','ordine 2')

