clear all
close all
% -((1+x)u'(x))'=1
% u(0)=0
% u(1)=0
% differenze finite
exact = @(x) -(x-log(x+1)/log(2));
a = 0;
b = 1;
mrange = 50:10:100;
counter = 0;
for m = mrange
  counter = counter+1;
  x = linspace(a,b,m)';
  h = (b-a)/(m-1);
  A = toeplitz(sparse([1,1],[1,2],[-2,1]/h^2,1,m));
  B = toeplitz(sparse(1,2,-1/(2*h),1,m),...
	     sparse(1,2,1/(2*h),1,m));
  M = -(B+spdiags(1+x,0,m,m)*A);
  M(1,1) = 1/h^2;
  M(1,2) = 0;
  M(m,m-1) = 0;
  M(m,m) = 1/h^2;
  rhs = ones(m,1);
  rhs(1) = 0;
  rhs(m) = 0;
  u = M\rhs;
  err(counter) = norm(u-exact(x),Inf);
end
loglog(mrange,err,'*',mrange,err(1)*(mrange/mrange(1)).^(-2))
legend('errore','ordine 2')

