clear all
lambda1 = 10+sqrt(101);
lambda2 = 10-sqrt(101);
alpha = 1/(exp(lambda1)-exp(lambda2));
beta = -alpha;
exact = @(x) alpha*exp(lambda1*x)+beta*exp(lambda2*x);
%exact = @(x) alpha*(2*exp(10*x).*sinh(sqrt(101)*x));
a = 0;
b = 1;
m = 20;
x = linspace(a,b,m)';
h = (b-a)/(m-1);
A = toeplitz(sparse([1,1],[1,2],[-2,1]/h^2,1,m));
B = toeplitz(sparse(1,2,-1/(2*h),1,m),...
	     sparse(1,2,1/(2*h),1,m));
M = A-20*B-speye(m);
M(1,1) = 1/h^2;
M(1,2) = 0;
M(m,m-1) = 0;
M(m,m) = 1/h^2;
rhs = zeros(m,1);
rhs(1) = 0;
rhs(m) = 1/h^2;
u = M\rhs;
norm(u-exact(x),inf)
x = -cos(linspace(pi/2,pi,m)');
h = diff(x);
A = spdiags([[2./(h(1:m-2).*(h(1:m-2)+h(2:m-1)));0;0],...
	     [0;-2./(h(1:m-2).*h(2:m-1));0],...
	     [0;0;2./(h(2:m-1).*(h(1:m-2)+h(2:m-1)))]],[-1,0,1],m,m);
B = spdiags([[-1./(h(1:m-2)+h(2:m-1));0;0],...
	    [0;0;1./(h(1:m-2)+h(2:m-1))]],[-1,1],m,m);
M = A-20*B-speye(m);
M(1,1) = 1/h(1)^2;
M(1,2) = 0;
M(m,m-1) = 0;
M(m,m) = 1/h(m-1)^2;
rhs = zeros(m,1);
rhs(1) = 0;
rhs(m) = 1/h(m-1)^2;
u = M\rhs;
norm(u-exact(x),inf)
